package dev.jansel.aglaea.database.collections

import dev.jansel.aglaea.database.Database
import dev.jansel.aglaea.database.entities.ConfigData
import dev.kordex.core.koin.KordExKoinComponent
import org.koin.core.component.inject
import org.litote.kmongo.exists

class ConfigCollection : KordExKoinComponent {
	private val db: Database by inject()

	@PublishedApi
	internal val collection = db.mongo.getCollection<ConfigData>()
	suspend fun get(): ConfigData? =
		collection.findOne()
	suspend fun set(config: ConfigData) =
		collection.insertOne(config)
	suspend fun update(config: ConfigData) =
		collection.findOneAndReplace(
			ConfigData::replaySession exists true,
			config
		)
	suspend fun delete() =
		collection.deleteOne(ConfigData::replaySession exists true)
	suspend fun deleteAll() =
		collection.deleteMany(ConfigData::replaySession exists true)
}
