package dev.jansel.aglaea.database.collections

import dev.jansel.aglaea.database.Database
import dev.jansel.aglaea.database.entities.ReplayData
import dev.kordex.core.koin.KordExKoinComponent
import org.koin.core.component.inject
import org.litote.kmongo.eq
import org.litote.kmongo.exists

class ReplayCollection : KordExKoinComponent {
	private val db by inject<Database>()

	@PublishedApi
	internal val collection = db.mongo.getCollection<ReplayData>()
	suspend fun getAll(): List<ReplayData> =
		collection.find().toList()
	suspend fun get(id: String): ReplayData? =
		collection.findOne(ReplayData::id eq id)
	suspend fun set(replay: ReplayData) =
		collection.insertOne(replay)
	suspend fun update(replay: ReplayData) =
		collection.findOneAndReplace(
			ReplayData::id eq replay.id,
			replay
		)
	suspend fun delete(id: String) =
		collection.deleteOne(ReplayData::id eq id)
	suspend fun deleteAll() =
		collection.deleteMany(ReplayData::id exists true)
}
