package dev.jansel.aglaea.extensions

import dev.jansel.aglaea.database.collections.ConfigCollection
import dev.jansel.aglaea.database.entities.ConfigData
import dev.jansel.aglaea.i18n.Translations
import dev.jansel.aglaea.logger
import dev.kord.common.entity.Permission
import dev.kordex.core.checks.hasPermission
import dev.kordex.core.extensions.Extension
import dev.kordex.core.extensions.ephemeralSlashCommand

class SessionExtension : Extension() {
	override val name = "Session"
	override suspend fun setup() {
		logger.info { "ReplaySession extension loaded!" }
		ephemeralSlashCommand {
			check {
				hasPermission(Permission.Administrator)
			}
			name = Translations.Commands.Replaysession.name
			description = Translations.Commands.Replaysession.description
			action {
				val toggle = ConfigCollection().get()?.replaySession ?: false
				if (toggle) {
					ConfigCollection().update(ConfigCollection().get()!!.copy(replaySession = false))
					respond {
						content = "Replay session disabled"
					}
				} else {
					if (ConfigCollection().get() == null) {
						ConfigCollection().set(ConfigData(true))
					} else {
						ConfigCollection().update(ConfigCollection().get()!!.copy(replaySession = true))
					}
					respond {
						content = "Replay session enabled"
					}
				}
			}
		}
	}
}
